=== cmake/packaging/CMakeLists.txt ===
add_subdirectory(deb)
add_subdirectory(rpm)
add_subdirectory(windows)

include(cpack_config.cmake)
