=== doc/man/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
     endforeach ()
 else ()
     message(STATUS "Manpage generation disabled")
-endif ()
+endif()
 
 # Install from output folder or this folder
 foreach (manpage ${MANPAGES})
@@ -27,10 +27,10 @@
         set(f "${CMAKE_CURRENT_SOURCE_DIR}/${manpage}.1")
     else()
         message(AUTHOR_WARNING "Manpage ${manpage} not generated")
-    endif ()
+    endif()
 
     if (f AND NOT WIN32)
-        install(FILES ${f} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/man/man1)
+        install(FILES ${f} DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
         unset(f)
-    endif ()
+    endif()
 endforeach ()
