=== debian/changelog ===
stlink (1.8.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:55:06 +1100

stlink (1.8.0-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:01:06 +0000

stlink (1.8.0-1) unstable; urgency=medium

  * Switch to gbp workflow, binary OSX blobs no longer included upstream
  * Merge tag 'upstream/1.8.0' into debian
  * Drop cross.patch, merged upstream
  * Install chips definitions in stlink-tools
  * Update symbols files for 1.8.0

 -- Luca Boccassi <bluca@debian.org>  Thu, 08 Feb 2024 19:28:19 +0000
