=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/stlink-$1\.tar\.gz/ \
  https://github.com/stlink-org/stlink/tags .*/v?(\d\S+)\.tar\.gz
